// vO SWP22.java: I[fBIĐ
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.sound.sampled.*;
public class SWP22 extends JPanel 
{
  public static void main(String[] args) 
       throws IOException,
              UnsupportedAudioFileException,
              LineUnavailableException
  {
    String name = args[0];
    File file = new File(name); 
    SoundPanel soundpanel 
            = new SoundPanel(file,name);
    JFrame frame = new JFrame("SWP22.java");
    frame.setDefaultCloseOperation(
                JFrame.EXIT_ON_CLOSE);
    frame.getContentPane().add(soundpanel);
    frame.pack();
    frame.setVisible(true);
  }
}
class SoundPanel extends JPanel
{
   Clip clip;
   boolean playing = false;
   int audioLength; 
   int audioPosition = 0;
   JButton play;
   JSlider progress;
   JLabel label;
   Timer timer;
   String name0;
   public SoundPanel(File f, String name)
       throws IOException,
              UnsupportedAudioFileException,
              LineUnavailableException
   {
      name0 = name;
      AudioInputStream ain 
          = AudioSystem.getAudioInputStream(f);
      try
      {
          DataLine.Info info =
              new DataLine.Info(
                  Clip.class,ain.getFormat());
          clip = (Clip) AudioSystem.getLine(info);
          clip.open(ain);
      }
      finally
      {
          ain.close();
      }
      audioLength 
           = (int)(clip.getMicrosecondLength()/1000);
      play = new JButton("Đ");
      label = new JLabel("Đt@C ");
      progress = new JSlider(0, audioLength, 0);
      play.addActionListener(new ActionListener()
      {
         public void actionPerformed(ActionEvent e) 
         {
             if(playing) stop(); 
               else        play();
         }
      });
      timer = new javax.swing.Timer(100, 
                            new ActionListener() 
      {
          public void actionPerformed(ActionEvent e)
          {
             tick();
          }
      });
      Box row = Box.createHorizontalBox();
      row.add(play);
      row.add(progress);
      row.add(label);
      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
      this.add(row);
   }
   public void play() 
   {
       clip.start();
       timer.start();
       play.setText("~");
       label.setText(name0+"̍Đ");
       playing = true;
   }
   public void stop() 
   {
       timer.stop();
       clip.stop();
       play.setText("Đ");
       label.setText("Đt@C ");
       playing = false;
   }
   public void reset() 
   {
       stop();
       clip.setMicrosecondPosition(0);
       audioPosition = 0; 
       progress.setValue(0);
   }
   public int getLength()
   {
      return audioLength;
   }
   void tick() 
   {
      if(clip.isActive()) 
      {
        audioPosition = (int)(
           clip.getMicrosecondPosition()/1000);
        progress.setValue(audioPosition);
      }
      else reset();  
   }
}